#pragma once

#include "TipModel.h"
#include "UpdaterDocument.h"
 #include "installcontroller.h"
#include "IPC/IPCCopyData.h"
#include "IPC/ipcinterface.h"
#include "TipAppDataManager.h"
#include "UpdaterView.h"
#include "Application.h"


namespace tipupdater
{
using namespace tipbase;

class ReceiveCallback : public IIPCReceiveCallback 
{
public:
	ReceiveCallback(UpdaterDocument* document):m_Document(document) {}
	int Callback(IPCPacket& packet, IIPCHandle *callback_handle );
private:
	UpdaterDocument* m_Document;
};

class ServerHooker : public tipbase::IPCCopyDataServerEventHooker
{
public:
	ServerHooker(UpdaterDocument* document):m_Document(document) 
	{
		m_callback = new ReceiveCallback(document);
	}
	~ServerHooker()
	{
		if (m_callback)
			delete m_callback;
		m_callback = NULL;
	}
	int Connected( tipbase::IIPCHandle *connectedHandle ) 
	{
		connectedHandle->SetReadCallback(m_callback);
		return 0;
	}

private:
	UpdaterDocument* m_Document;
	ReceiveCallback* m_callback;
};

class NotifyWindowManager;
class CheckCoreValue;
class TimerEventTriggerHandler;

class UpdaterModel : public TipModel
{
public:
	UpdaterModel(void);
	virtual ~UpdaterModel(void);
	void Init();
	void Close();
	UpdaterDocument* GetDocument() { return &m_Document; }

 	void SetInstallControllerCallback(/*IInstallController* controller,*/ IInstallControllerCallback* callback)
 	{
 // 		if (m_InstallController)
 // 			delete m_InstallController;
 // 		m_InstallController = controller;
 
 		if (m_InstallCallback)
 			delete m_InstallCallback;
 		m_InstallCallback = callback;
 	}
 	IInstallController* GetInstallController()
 	{
 		if (m_InstallController == NULL)
 		{
 			IInstallController* controller = CreateInstallController();
 			if (!controller->Create())
 			{
 				delete controller;
 				return NULL;
 			}
 			m_InstallController = controller;
 		}
 		return m_InstallController;
 	}
 //	IInstallController* GetInstallController() { return m_InstallController; }
	TipAppDataManager* GetAppDataManager() { return &m_AppDataManager; }

	tipbase::IPCCopyDataServer* GetIPCServer() { return &m_server; }
	BOOL IsTestRun();
private:
	UpdaterDocument m_Document;

	NotifyWindowManager *m_notifyWindowManager;
	TimerEventTriggerHandler *m_timerEventTriggerHandler;
	//CheckCoreValue *m_checkCoreValue;

 	IInstallController* m_InstallController;
 	IInstallControllerCallback* m_InstallCallback;
	tipbase::IPCCopyDataServer m_server;
	ServerHooker* m_hooker;
	TipAppDataManager m_AppDataManager;
};




};